#!C:/usr/perl/bin/perl.exe

#XMail Stats v1.3
#Coded By Richard Mayhew
#Email richard@splash.co.za
#Web   http://www.splash.co.za
#Modified by Senshu <senshu@shonai-cit.ac.jp>
# TAB = 4SP
#
#-------------------------------------------------------------#
# Coded For XMail 0.71+ 2001               Released Under GPL #
# Written By Richard Mayhew                                   #
#-------------------------------------------------------------#
# 2001-12   (ver 1.3A) ... 1st release.
# 2002-2-13 (ver 1.3C) ... k4log add.
# 2002-2-14 .............. Web browser info add.
# 2002-2-15 (ver 1.3D) ... Web browser info mod.
# 2002-2-18 (ver 1.3D) ... Print format string "----" Adj.
# 2002-4-13 (ver 1.3E) ... Fix (Devide by 0)
#
###
if($ENV{'SERVER_SOFTWARE'}=~/IIS/){my $cd=$0;$cd=~s/[^\\]*$//;chdir($cd);}
require "./jcode.pl";
require "./config.cgi";
my $mail_root = "$cfg{mailroot}";
my $date_spec = "$ARGV[0]";
my $log_muilti_files = 0;
my $log_match_pattern = "";
###

# ---------------------------------- [ VARS ] --
use strict;
use Time::Local;
use File::Basename;

##### Vars.

my $localhostname = `hostname`;
my $logfile_dir = "$mail_root/logs";
my $version = "1.3E";

# Need '0' clear var.
my (
	$LOCAL, $SMTP, $POP3, $SERVER, $RESULTS, $k4_RESULTS, $AUTH,
	$pop_count, $smtp_count, $smail_count, $k4_count,
	$smail_log_count, $pop3_log_count, $smtp_log_count,
	$k4_log_count, $all_log_count
);

#
my (
	@input, $logline,
	$localdomain, $message_file, $message_id, $from, $to, $type,
	$remote_domain, $datetime, $auth, $size, $typeofsize, $totalcount,
	$input, $date, @log_files,
	$path1, $basename
);

#
my (
	%results, %k4_results, %k4_webclients, %k4_ip_addr,
	%domain_in, %domain_out, %from_domain, %domain,
	%username, %user_email, %time_smtp_in, %time_smtp_out,
	%authuser
);

#
my (
	$user, $domain, $mail_total, $count, $time, $popdomain,
	$from_ip, $password, $userdomain, $in_domain, $inlocal,
	$msgid, $result, $hour, $min, $sec, $authuser, $newhour,
	$target_date, $target_disp
);

# Need init string var.
my $log_date = "";
my $currentdate = "";
my $file_status = "";
my $log_file = "";

# -----------------------------------[ Init. ] --

$LOCAL = $SMTP = $POP3 = $SERVER = $RESULTS = $k4_RESULTS = $AUTH = 0;
$pop_count = $smtp_count = $smail_count = $k4_count = 0;
$smail_log_count = $pop3_log_count = $smtp_log_count = 0;
$k4_log_count = $all_log_count = 0;

### Set today, yesterday
my ($mday, $mon, $month, $year, $wday, $yday, $isdst, $now);
if ($date_spec eq "all") {
	$log_muilti_files = 1;
	$log_match_pattern = '*';
} elsif ($date_spec =~ /-/) {
	($year, $month) = split('-', $date_spec, 2);
	if (($year < 2000) || !($month >= 1 && $month <= 12)) {
		$log_muilti_files = 0;
		$date_spec = 0;
	} else {
		$log_muilti_files = 1;
		$log_match_pattern = sprintf("%4d%02d*", $year, $month);
  }
} else {
	$log_muilti_files = 0;
	$date_spec = abs($date_spec);
	if ($date_spec > 1000) {
		$date_spec = 0;
	}
}

($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime(time);
$year = ($year + 1900);
$month = ($mon + 1);
$currentdate = sprintf("%04d-%02d-%02d %02d:%02d:%02d",
				$year, $month, $mday, $hour, $min, $sec);

($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst)
 = localtime(time - ($date_spec*24*60*60));
$year = ($year + 1900);
$month = ($mon + 1);
$target_date = sprintf("%04d%02d%02d", $year, $month, $mday);

if ($log_muilti_files) {
	$target_disp = "";
} else {
	$target_disp = sprintf("%04d-%02d-%02d", $year, $month, $mday);
}
$log_date = sprintf("%s0000", $target_date);


chomp $localhostname;


# -----------------------------------[ MAIN ] --
MAIN:

#Read in Log File (READ ONLY)
# SMAIL
if ($log_muilti_files) {
	$log_file = "$logfile_dir/smail-" . $log_match_pattern;
} else {
	$log_file = "$logfile_dir/smail-$log_date";
}
$smail_log_count = 0;
foreach (glob($log_file)) {
	$input = "";
	if (open (LOGFILE, "<$_")) {
		push @log_files, substr(basename($_), 0, 14);
		$smail_log_count++;
		while (<LOGFILE>) { $input .= $_; }
		close(LOGFILE);
		$input =~ s/\"//g;
		@input = split ("\n", $input);

		#Process Data
		foreach $logline (@input) {
			($localdomain, $message_file, $message_id, $from, $to,
					$type, $remote_domain, $date, $time)
						= split (" ", $logline,9);
			($user, $domain) = split ("@", $to,2);
			$domain = lc($domain);

			($hour, $min, $sec) = split(":", $time,3);

			if ($type eq "LOCAL") {
				$LOCAL++;
				$domain_in{$domain}++;
				$user_email{$remote_domain}++;
				$time_smtp_in{$hour}++;
			}

			if ($type eq "SMTP") {
				$SMTP++;
				$domain_out{$domain}++;
				$time_smtp_out{$hour}++;
			}
			$smail_count++;
		}
	} else {
		$file_status .= "[$_]";
	}
}

# POP3
if ($log_muilti_files) {
	$log_file = "$logfile_dir/pop3-" . $log_match_pattern;
} else {
	$log_file = "$logfile_dir/pop3-$log_date";
}
foreach (glob($log_file)) {
	$input = "";
	if (open (LOGFILE, "<$_")){
		push @log_files, substr(basename($_), 0, 13);
		$pop3_log_count++;
		while (<LOGFILE>) { $input .= $_; }
		close(LOGFILE);
		$input =~ s/\"//g;
		@input = split ("\n", $input);

		foreach $logline (@input) {
			($localdomain, $popdomain, $from_ip,
			$date, $time, $user, $password)
				= split (" ", $logline, 7);
			$POP3++;
		        $domain{$popdomain}++;
			$userdomain = lc("$user\@$popdomain");
			$username{$userdomain}++;
			$pop_count++;
		}
	} else {
#		$file_status .= "[$_]";
	}
}

# SMTP
if ($log_muilti_files) {
	$log_file = "$logfile_dir/smtp-" . $log_match_pattern;
} else {
	$log_file = "$logfile_dir/smtp-$log_date";
}
foreach (glob($log_file)) {
	$input = "";
	if (open (LOGFILE, "<$_")) {
		push @log_files, substr(basename($_), 0, 13);
		$smtp_log_count++;
		while (<LOGFILE>) { $input .= $_; }
		close(LOGFILE);
		@input = split ("\n", $input);

		foreach $logline (@input) {
			$logline =~ s/\"/\|/g;
			$logline =~ s/\s+/#/g;

		        if ($logline =~ /RECV/) {
					($localdomain, $popdomain, $from_ip,
					 $date, $time, $in_domain, $inlocal, $from, $to,
					 $msgid, $result, $auth, $size)
					 = split ("#", $logline, 13);

					$in_domain =~ s/\|//g;
					$in_domain = lc($in_domain);
					$auth =~ s/\|//g;
					$size =~ s/\|//g;
					$result =~ s/\|//g;
					$msgid =~ s/\|//g;

					$SERVER++;
					$from_domain{$in_domain}++;
					$mail_total = $mail_total + $size;
					if ($auth ne "") { $authuser{$auth}++; $AUTH++;}
					if ($result =~ /RECV/) {
						$results{$result}++;
						$RESULTS++;
					}
		        } else {
					($localdomain, $popdomain, $from_ip, $date, $time,
						$in_domain, $inlocal, $from, $to,
						$msgid, $result, $auth, $size)
						= split ("#", $logline, 13);
					$result =~ s/\|//g;
					$results{$result}++; $RESULTS++;
		        }
			$smtp_count++;
		}
	} else {
		$file_status .= "[$_]";
	}
}

# K4
if ($log_muilti_files) {
	$log_file = "$logfile_dir/k4-" . $log_match_pattern;
} else {
	$log_file = "$logfile_dir/k4-$log_date";
}


foreach (glob($log_file)) {
	my ($p1, $p2, $p3, $p4, $p5, $p6, $p7, $p8, $p9);
	my ($ip, $browser);

	$input = "";
	if (open (LOGFILE, "<$_")) {
		push @log_files, substr(basename($_), 0, 13);
		$k4_log_count++;
		while (<LOGFILE>) { $input .= $_; }
		close(LOGFILE);
		@input = split ("\n", $input);

		foreach $logline (@input) {
			($p1, $p2, $p3, $p4, $p5, $p6, $p7, $p8, $p9)
								= split ("\t", $logline, 9);
			$k4_results{$p7}++;
			($ip, $browser) = split('\/', $p9, 2);

			### ip address convert
			($p1, $p2, $p3, $p4) = split(/[.]/, $ip);
			$ip = sprintf("%3d.%3d.%3d.%3d", $p1, $p2,$p3, $p4);

			###
			$_ = $browser;
			$browser =~ s/Windows; // ;
			$browser =~ s/compatible; // ;
			$browser =~ s/U; // ;
			$browser =~ s/X11; // ;

			###
			$k4_webclients{$browser}++;
			$k4_ip_addr{$ip}++;
			$k4_RESULTS++;
			$k4_count++;
		}
	}
}

#Print OutPut
printf "Content-Type: text/html; charset=EUC-JP\n";
printf "CacheControl: no-cache\nPragma: no-cache\nExpires: -1\n\n";
print <<EOD;
<html>
<body bgcolor='#ffffff'>
<p><b><a href="javascript:history.go( -1)">&lt;&lt;Back</a></b></p>
XMailStats<br>
Written By: Richard Mayhew<br>
Modified By: Senshu Hiroyuki<br>
Version: $version<br>
<PRE>
EOD

printf "  XMail Stats Information\n";
printf "#-------------------------------------------------------------#\n";
printf "  Hostname          = ${localhostname}\n";
printf "  Date/Time         = ${currentdate}\n";
my $i = 0;
foreach (@log_files) {
	if ($i == 0) {printf "\n  ";}
	printf "%14s ", $_;
	$i++;
	if (($i % 4) == 0) {printf "\n  ";}
}
if ($i) {printf "\n";}
printf "#-------------------------------------------------------------#\n";
printf "\n";


if ($file_status) {
	printf "LOG file not found (%s)\n", $file_status;
} else {
	my $s;

	printf "  Mail Server Results                   Total : %8d\n", $RESULTS;
	printf "#-------------------------------------------------------------#\n";
	$count=1;
	foreach $s (sort keys %results) {
		if ($s =~ /OK/) {
			printf "%4d %-40s | %8d\n",	$count, $s, $results{$s};
		} else {
			printf "<font color='red'>";
			printf "%4d %-40s | %8d\n",	$count, $s, $results{$s};
			printf "</font>";
		}
		$count++;
	}

	printf "\n\n";
	printf "  Hourly Incoming Mail                  Total : %8d\n", $LOCAL;
	printf "#-------------------------------------------------------------#\n";
	foreach $s (sort keys %time_smtp_in) {
		$newhour = "$s:00:00";
		printf "%14s %-30s | %8d\n", $target_disp, $newhour, $time_smtp_in{$s};
	}

	printf "\n\n";
	printf "  Hourly Outgoing Mail                  Total : %8d\n", $SMTP;
	printf "#-------------------------------------------------------------#\n";
	foreach $s (sort keys %time_smtp_out) {
		$newhour = "$s:00:00";
		printf "%14s %-30s | %8d\n", $target_disp, $newhour, $time_smtp_out{$s};
	}

	if ($mail_total >= 1024) { $typeofsize = "B";}
	if ($mail_total > 1024) { $mail_total /= 1024; $typeofsize = "KB";}
	if ($mail_total > 1024) { $mail_total /= 1024; $typeofsize = "MB";}
	$totalcount = $smail_count + $pop_count + $smtp_count;

	printf "\n\n";
	printf "  Extra Statistics\n";
	printf "#-------------------------------------------------------------#\n";
	printf "Total Mail Delivered                 | %5.2f %s\n\n", $mail_total, $typeofsize;
	printf "Log Lines Processed                           : %8d\n", $totalcount;
	printf "#-------------------------------------------------------------#\n";
	printf "     (SMAIL)                         | %6d\n", $smail_count;
	printf "     (POP3)                          | %6d\n", $pop_count;
	printf "     (SMTP)                          | %6d\n", $smtp_count;

	$all_log_count = $smail_log_count + $pop3_log_count + $smtp_log_count;
	printf "#-------------------------------------------------------------#\n";
	if ($smail_log_count > 1) {
		printf "     (SMAIL/DAY)                     | %6d\n", $smail_count/$smail_log_count;
	}
	if ($pop3_log_count > 1) {
		printf "     (POP3/DAY)                      | %6d\n", $pop_count/$pop3_log_count;
	}
	if ($smtp_log_count > 1) {
		printf "     (SMTP/DAY)                      | %6d\n", $smtp_count/$smtp_log_count;
	}
	if ($all_log_count) {
		printf "#-------------------------------------------------------------#\n";
	}

	if ($k4_log_count) {
		printf "\n\n";
		printf "#-------------------------------------------------------------------------------------#\n";
		if ($k4_log_count == 1) {
			printf "  k4 access Results                     Total : %8d\n", $k4_RESULTS;
		} else {
			printf "  k4 access Results                     Total : %8d (%d/DAY)\n",
				$k4_RESULTS, $k4_RESULTS / $k4_log_count;
		}
		printf "#-------------------------------------------------------------------------------------#\n";
		$count=1;
		foreach $s (sort keys %k4_results) {
			printf "%4d %-75s | %4d\n",	$count, $s, $k4_results{$s};
			$count++;
		}
		printf "#-------------------------------------------------------------------------------------#\n";
		$count=1;
		foreach $s (sort keys %k4_webclients) {
			printf "%4d %-75s | %4d\n",	$count, $s, $k4_webclients{$s};
			$count++;
		}
		printf "#-------------------------------------------------------------------------------------#\n";
		$count=1;
		foreach $s (sort keys %k4_ip_addr) {
			my $p = $k4_ip_addr{$s};
			$_ = $s;
			$s =~ s/ //g;
			printf "%4d %-75s | %4d\n",	$count, "Client IP Address = [$s]", $p;
			$count++;
		}
		printf "#-------------------------------------------------------------------------------------#\n";
	}

	printf "\n\n";
	printf "  Incoming Mail (per Domain)            Total : %8d\n", $LOCAL;
	printf "#-------------------------------------------------------------#\n";
	$count=1;
	foreach $s (sort keys %domain_in) {
		printf "%4d %-40s | %8d\n", $count, $s, $domain_in{$s};
		$count++;
	}

	printf "\n\n";
	printf "  Outgoing Mail (per Domain)            Total : %8d\n", $SMTP;
	printf "#-------------------------------------------------------------#\n";
	$count=1;
	foreach $s (sort keys %domain_out) {
		printf "%4d %-40s | %8d\n", $count, $s, $domain_out{$s};
		$count++;
	}

	printf "\n\n";
	printf "  POP3 Mail Checks (per Domain)         Total : %8d\n", $POP3;
	printf "#-------------------------------------------------------------#\n";
	$count=1;
	foreach $s (sort keys %domain) {
		printf "%4d %-40s | %8d\n", $count, $s, $domain{$s};
		$count++;
	}

	printf "\n\n";
	printf "  POP3 Mail Checks (per User)           Total : %8d\n", $POP3;
	printf "#-------------------------------------------------------------#\n";
	$count=1;
	foreach $s (sort keys %username) {
		printf "%4d %-40s | %8d\n", $count, $s, $username{$s};
		$count++;
	}

	printf "\n\n";
	printf "  SMTP User Authentication              Total : %8d\n", $AUTH;
	printf "#-------------------------------------------------------------#\n";
	$count=1;
	foreach $s (sort keys %authuser) {
		printf "%4d %-40s | %8d\n", $count, $s, $authuser{$s};
		$count++;
	}

	printf "\n\n";
	printf "  Incoming Mail (per User)              Total : %8d\n", $LOCAL;
	printf "#-------------------------------------------------------------#\n";
	$count=1;
	foreach $s (sort keys %user_email) {
		printf "%4d %-40s | %8d\n", $count, $s, $user_email{$s};
		$count++;
	}

	printf "\n\n";
	printf "  Incoming Mail (per Server)            Total : %8d\n", $SERVER;
	printf "#-------------------------------------------------------------#\n";
	$count=1;
	foreach $s (sort keys %from_domain) {
		printf "%4d %-40s | %8d\n", $count, $s, $from_domain{$s};
		$count++;
	}
}

printf "\n\n";
printf "#----------------------XMail Stats $version-----------------------#\n";

print <<EOD;
</pre>
</body>
</html>
EOD

1;
